import { Provider } from '@coral-xyz/anchor';
import { ValidatorAccount } from '@solana/spl-stake-pool/dist/utils';
import { Connection, PublicKey, TransactionInstruction } from '@solana/web3.js';
import { MarinadeState } from '../marinade-state/marinade-state';
export declare function computeExpectedSOL(amountToWithdraw: number, cxn: Connection, stakePoolTokenAddress: PublicKey): Promise<number>;
export declare function computeLSTValueInSOL(amount: number, cxn: Connection, stakePoolTokenAddress: PublicKey): Promise<number>;
export declare function identifyValidatorFromTx(instructions: TransactionInstruction[], provider: Provider, marinadeState: MarinadeState): Promise<{
    validatorAddress: PublicKey;
    duplicationFlag: PublicKey;
    validatorIndex: number;
}>;
export declare function selectSpecificValidator(a: ValidatorAccount, b: ValidatorAccount, validators: Set<string>): number;
